pipeline {
    agent none

    stages {
        stage('build') {
            agent {
                docker {
                    image 'node'
                }
            }
            steps {
                dir ('website') {
                    sh 'npm i'
                    sh 'npm run build'
                }
            }
            post {
                success {
                    archiveArtifacts artifacts: "website/build/test-site/", fingerprint: true
                }
            }
        }
        stage('test') {
            parallel {
                stage('code analysis') {
                    agent {
                        docker {
                            image 'node:lts'
                            args '--network iesp-curso-jenkins_devopsjenkins'
                        }
                    }
                    environment {
                        scannerHome = tool 'SonarQubeScanner'
                    }
                    steps {
                        withSonarQubeEnv('sonarqube') {
                            sh "${scannerHome}/bin/sonar-scanner"
                        }
                        timeout (time: 10, unit: 'MINUTES') {
                            waitForQualityGate abortPipeline: true
                        }
                    }
                }
            }
        }
    }
}